<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 45.40</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Data Table Style-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.min.js"></script>
  <!-- AdminLTE for demo purposes -->
  <script src="dist/js/demo.js"></script>
  <script>
      $(document).ready(function(){
    /***************************** REGION 1 *********************************/
    const gORDER_ID_COL = 0;
    const gCOMBO_COL = 1;
    const gFLAVOR_COL = 2;
    const gDRINK_COL = 3;
    const gPRICE_COL = 4;
    const gNAME_COL = 5;
    const gPHONE_NUMBER_COL = 6;
    const gSTATUS_COL = 7;
    const gDETAIL_COL = 8;

    const gColNames = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong","thanhTien", "hoTen", "soDienThoai", "trangThai", "detail"]

    var gAllUsersObj = [];

    var gSelectedId = null;

    var gSelectedOrderId = null;

    var gTable = $("#order-table").DataTable({
            columns: [
                { data : gColNames[gORDER_ID_COL] },
                { data : gColNames[gCOMBO_COL] },
                { data : gColNames[gFLAVOR_COL] },
                { data : gColNames[gDRINK_COL] },
                { data : gColNames[gPRICE_COL] },
                { data : gColNames[gNAME_COL] },
                { data : gColNames[gPHONE_NUMBER_COL] },
                { data : gColNames[gSTATUS_COL] },
                { data : gColNames[gDETAIL_COL] }
            ],
            columnDefs: [
                {
                    targets: gDETAIL_COL,
                    defaultContent: '<i title="Detail" class="fa-solid fa-circle-info detail-icon" style="color:blue; cursor:pointer"></i>'
                }
            ]
        })

    onPageLoading();
    /***************************** REGION 2 *********************************/
    // Gán sự kiện ấn cho icon detail:
    $(document).on('click', '.detail-icon', function(){
        onDetailIconClick(this);
    })

    // Gán sự kiện cho nút lọc:
    $("#btn-filter").on('click', function(){
        onBtnFilterClick();
    })

    // Gán sự kiện cho nút confirm update đơn hàng:
    $("#btn-confirm-order").click(function(){
        onBtnConfirmUpdateClick();
    })
    
    // Gán sự kiện cho nút cancel order:
    $("#btn-cancel-order").click(function(){
        onBtnCancelOrderClick();
    })
    /***************************** REGION 3 *********************************/
    // Hàm xử lý sự kiện nút cancel order:
    function onBtnCancelOrderClick() {
        'use strict'
        console.log("Selected ID: " + gSelectedId)
        // B1: 
        var vObjectRequest = {
            trangThai: "cancel"
        };
        // B2: validate (không cần thiết)
        // B3: call api:
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + gSelectedId,
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(vObjectRequest),
            type: "PUT",
            // B4:
            success: function(responseObj){
                xuLyFrontEndCancel(responseObj);
            }
        })
    }

    // Hàm xử lý sự kiện confirm update order:
    function onBtnConfirmUpdateClick() {
        'use strict'
        // B1: 
        var vObjectRequest = {
            trangThai: "confirmed"
        };
        // B2: validate (không cần thiết)
        // B3: call api:
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + gSelectedId,
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(vObjectRequest),
            type: "PUT",
            // B4:
            success: function(responseObj){
                xuLyFrontEnd(responseObj);
            }
        })
    };
    // Hàm xử lý sự kiện trang được tải:
    function onPageLoading() {
        // Gọi Api lấy all users
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
            type: "GET",
            dataType: "json",
            success: function(responseObj){
                gAllUsersObj = responseObj;
                loadDataToTable(responseObj);
            }
        })
    }

    // Hàm xử lý icon chi tiết được ấn:
    function onDetailIconClick(paramIcon){
        // B1:
        var vTable = $("#order-table").DataTable();
        var vRowClicked = $(paramIcon).closest('tr');
        var vData = vTable.row(vRowClicked).data();
        gSelectedId = vData.id;
        gSelectedOrderId = vData.orderId;
        // B2: 
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + gSelectedOrderId,
            type: "GET",
            dataType: "json",
            success: function(responseObj){
                loadDataToForm(responseObj)
            }
        });

        $("#modal-order-detail").modal('show')
    }
    
    // Hàm xử lý nút lọc được ấn:
    function onBtnFilterClick() {
        // B1: 
        var vFilterObj = {
            status: "",
            flavor: ""
        }
        getDataFromForm(vFilterObj);
        // B2: 
        var vFilterResult = filterData(vFilterObj);
        // B3: 
        loadDataToTable(vFilterResult)
    }
    /***************************** REGION 4 *********************************/
    // Hàm xử lý front end khi cancel thành công:
    function xuLyFrontEndCancel(){
        alert("Order canceled!");
        location.reload();
    }

    // Hàm xử lý front-end khi update thành công:
    function xuLyFrontEnd(paramResponseObj){
        alert("Order confirmed!");
        $("#modal-order-detail").modal('hide');
        location.reload();
    }

    // Hàm hiển thị dữ liệu lên form:
    function loadDataToForm(paramResponseObj) {
        console.log(paramResponseObj)
        $("#inputAddress").val(paramResponseObj.diaChi);
        $("#inputDuongKinh").val(paramResponseObj.duongKinh);
        $("#inputEmail").val(paramResponseObj.email);
        $("#inputGiamGia").val(paramResponseObj.giamGia);
        $("#inputName").val(paramResponseObj.hoTen);
        $("#inputId").val(paramResponseObj.id);
        $("#selectDrink").val(paramResponseObj.idLoaiNuocUong).change();
        $("#inputVoucherId").val(paramResponseObj.idVourcher);
        $("#select-size").val(paramResponseObj.kichCo).change();
        $("#select-flavor").val(paramResponseObj.loaiPizza.toLowerCase()).change();
        $("#inputMessage").val(paramResponseObj.loiNhan);
        $("#inputNgayCapNhat").val(paramResponseObj.ngayCapNhat);
        $("#inputCreateDate").val(paramResponseObj.ngayTao);
        $("#inputSalad").val(paramResponseObj.salad);
        $("#inputSDT").val(paramResponseObj.soDienThoai);
        $("#inputDrinkNumber").val(paramResponseObj.soLuongNuoc);
        $("#inputRib").val(paramResponseObj.suon);
        $("#inputPrice").val(paramResponseObj.thanhTien);
        $("#inputStatus").val(paramResponseObj.trangThai);
    };

    // Hàm lọc dữ liệu:
    function filterData(paramFilterObj){
        'use strict'
        var vFilterResult = [];
        vFilterResult = gAllUsersObj.filter(function(paramOrder){
            return ( (paramFilterObj.status.toLowerCase() == paramOrder.trangThai.toLowerCase() || paramFilterObj.status == "all") && 
                     (paramFilterObj.flavor.toLowerCase() == paramOrder.loaiPizza.toLowerCase() || paramFilterObj.loaiPizza == "all") )
        })
        return vFilterResult;
    }

    // Hàm thu thập dữ liệu được chọn:
    function getDataFromForm(paramFilterObj){
        'use strict'
        paramFilterObj.status = $("#select-status option:selected").val();
        paramFilterObj.flavor = $("#select-flavor option:selected").val();
    };

    // Hàm đổ dữ liệu vào bảng:
    function loadDataToTable(paramOrdersObj){
        gTable.clear();
        gTable.rows.add(paramOrdersObj);
        gTable.draw();
    }
    
})
  </script>
  

</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="../../index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
    
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Task 45.50</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Viet Le</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Vouchers</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="users.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Users</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Filter Orders</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Filter Orders</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Filter Orders</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
        <body>
            <div class="container mt-5">
                <div class="row">
                    <div class="col-12 text-center">
                        <h2>DANH SÁCH ĐƠN HÀNG</h2>
                    </div>
                </div>
                <div class="row">
                    
                    <div class="container jumbotron my-5">
                        <div class="row form-group">
                            <div class="col-sm-2">Trạng thái order</div>
                            <div class="col-sm-3">
                                <select class="form-control" name="" id="select-status">
                                    <option value="all">...</option>
                                    <option value="open">Open</option>
                                    <option value="confirmed">Confirmed</option>
                                    <option value="cancel">Cancel</option>
                                </select>
                            </div>
                            <div class="col-sm-2">Loại Pizza</div>
                            <div class="col-sm-3">
                                <select class="form-control" name="" id="select-flavor">
                                    <option value="all">...</option>
                                    <option value="hawaii">Hawaii</option>
                                    <option value="bacon">Bacon</option>
                                    <option value="seafood">Seafood</option>
                                </select>
                            </div>
                            <div class="col-sm-2">
                                <button id="btn-filter" class="btn btn-info">Lọc Order</button>
                            </div>
                        </div>
                        </div>
                    
                </div>
                <div class="row">
                    <table class="table table-bordered table-striped table-hover" id="order-table">
                        <thead>
                            <tr>
                                <th>Order ID</th>
                                <th>Combo</th>
                                <th>Flavor</th>
                                <th>Drink</th>
                                <th>Price</th>
                                <th>Name</th>
                                <th>Phone Number</th>
                                <th>Status</th>
                                <th>Detail</th>
                            </tr>
                        </thead>
                    </table>
                </div>
                <!-- Vùng Modal -->
                <div id="modal-order-detail" class="modal fade" tabindex="-1" role="dialog">
                    <div class="modal-dialog" role="document">
                      <div class="modal-content">
                        <div class="modal-header">
                          <h5 class="modal-title">Order Details</h5>
                          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                          </button>
                        </div>
                        <div class="modal-body">
        
                          <div class="row form-group">
                              <div class="col-sm-3">Địa chỉ</div>
                              <div class="col-sm-9">
                                  <input type="text" name="" id="inputAddress" class="form-control">
                              </div>
                          </div>
        
                          <div class="row form-group">
                            <div class="col-sm-3">Đường Kính</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputDuongKinh" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Email</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputEmail" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Giảm Giá</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputGiamGia" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Họ Tên</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputName" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">ID</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputId" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Drink</div>
                            <div class="col-sm-9">
                                <select class="form-control" name="" id="selectDrink">
                                    <option value="TRATAC">Trà Tắc</option>
                                    <option value="COCA">Cocacola</option>
                                    <option value="PEPSI">Pepsi</option>
                                    <option value="LAVIE">Lavie</option>
                                    <option value="TRASUA">Trà sữa trân châu</option>
                                    <option value="FANTA">Fanta</option>
                                </select>
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Voucher Id</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputVoucherId" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Kích Cỡ</div>
                            <div class="col-sm-9">
                                <select name="" id="select-size" class="form-control">
                                    <option value="S">S</option>
                                    <option value="M">M</option>
                                    <option value="L">L</option>
                                </select>
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Loại Pizza</div>
                            <div class="col-sm-9">
                                <select name="" class="form-control" id="select-flavor">
                                    <option value="bacon">bacon</option>
                                    <option value="hawaii">hawaii</option>
                                    <option value="seafood">seafood</option>
                                </select>
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Lời nhắn</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputMessage" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Ngày cập nhật</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputNgayCapNhat" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Ngày tạo</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputCreateDate" class="form-control">
                            </div>
                        </div>
        
        
                        <div class="row form-group">
                            <div class="col-sm-3">Salad</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputSalad" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Số Điện Thoại</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputSDT" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Số lượng nước</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputDrinkNumber" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Sườn</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputRib" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Thành tiền</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputPrice" class="form-control">
                            </div>
                        </div>
        
                        <div class="row form-group">
                            <div class="col-sm-3">Trạng thái</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="inputStatus" class="form-control">
                            </div>
                        </div>
                        </div>               
                        <div class="modal-footer">
                          <button id="btn-confirm-order" type="button" class="btn btn-info">Confirm</button>
                          <button id="btn-cancel-order" type="button" class="btn btn-danger" data-dismiss="modal">Cancel</button>
                        </div>
                      </div>
                    </div>
                  </div>
            </div>
        </body>
      
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">Devcamp120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->


</body>
</html>
